
* EXAMPLE #1;

data drg_fmt;
retain fmtname '$drg';
infile "k:\workshops\hw08\drgs.dat" truncover;
input start $3. +1 label $70.;
run;

proc format cntlin=drg_fmt;
*select $drg;
run;

data test;
input id : $5. drg : $3. @@;
datalines;
12345 001 34567 005 67890 310 99999 002 87654 004 44444 062 55555 059 12121 888
;
run;

title 'FORMAT CREATED WITH A CNTLIN DATA SET';
proc report data=test nowd;
columns id drg drg=drglabel;
define drglabel / format=$drg.;
run;
title;

* ADD AN OTHER CONDITION;

data drg_fmt;
retain fmtname '$drg';
infile "K:\workshops\hw08\drgs.dat" truncover end=last;
input start $3. +1 label $50.;
output;
if last then do;
   hlo = 'o';
   label = 'UNKNOWN';
   output;
end;
run;

proc format cntlin=drg_fmt;
select $drg;
run;

data test;
input id : $5. drg : $3. @@;
datalines;
12345 001 34567 005 67890 310 99999 002 87654 004 44444 062 55555 059 12121 888
;
run;

title 'FORMAT CREATED WITH A CNTLIN DATA SET (HLO VARIABLE ADDED)';
proc report data=test nowd;
columns id drg drg=drglabel;
define drglabel / format=$drg.;
run;
title;

* codes and lables in an Access data base;

libname x access path="k:\monsug\codes.mdb";

* use a data step to create a CNTLIN data set;

data fmt;
retain fmtname '$hosp2name';
* read a table in the Access data base;
set x.hospitals (rename=(code=start name=label)) end=last;
output;
if last then do;
   hlo = 'o';
   label = 'UNKNOWN';
   output;
end;
run;

proc format cntlin=fmt;
select $hosp2name;
run;

libname x clear;

* EXAMPLE #2 - PUTN & PUTC;

proc format;  
value age2_  low - 17.9 = 'normal'  18.0 - 19.0 = 'risk'  19.1 - high = 'overweight';
value age3_  low - 17.1 = 'normal'  17.2 - 18.1 = 'risk'  18.2 - high = 'overweight';
value age4_  low - 16.7 = 'normal'  16.8 - 17.9 = 'risk'  18.0 - high = 'overweight';
value age5_  low - 16.7 = 'normal'  16.8 - 18.1 = 'risk'  18.2 - high = 'overweight';
run;

data bmi;
length bmi_group $10;
input age_group : $1. bmi @@;

* PUTN accepts a variable as the 2nd argument;
* format varies by age  group;

bmi_group=putn(bmi,cat('age',age_group,'_')); 

datalines;
2 17.8 5 16.7 2 18.6 3 17.6 4 17.0 3 18.2 4 18.0
;
run;

title 'BMI_GROUP ADDED USING THEN PUTN FUNCTION';
proc print data=bmi;
run;
title;

proc format;
value $FR 'A'-'D' = 'PASS' other = 'FAIL';
value $SO 'A'-'C' = 'PASS' other = 'FAIL';
value $JR 'A'-'B' = 'PASS' other = 'FAIL';
value $SR 'A'     = 'PASS' other = 'FAIL';
run;

data students;
length pass_fail $4.;
input class : $2. grade : $1. @@;
pass_fail = putc(grade,cat('$',class));
datalines;
FR D SO A SO D JR B JR C SR A SR B
;
run;

title 'PASS_FAIL ADDED USING THE PUTC FUNCTION';
proc print data=students;
var class grade pass_fail;
run;
title;

* EXAMPLE #3 - NESTED FORMATS;

* ASSUME THIS IS A FORMAT IN A FORMAT LIBRARY;

proc format;
value $num2nam  
'0001'  = 'ALBANY MEDICAL CENTER HOSPITAL'
'0002'  = 'CHILDS HOSPITAL'
'0005'  = 'ST PETERS HOSPITAL'
'0012'  = 'OSWEGO HOSPITAL'
'0016'  = 'CATHOLIC MED CTR'
'0025'  = 'COHOES MEMORIAL HOSPITAL'
other   = 'UNKNOWN'
;
select $num2nam;
run;

* MAKE TWO MODIFICATIONS - ONE ADDITION, ONE LABEL CHANGE';

proc format;
value $numplus
'0004' = 'MEMORIAL HOSPITAL'
'0016' = 'CATHOLIC MED CTR (***CLOSED***)'
other  = [$num2nam35.]  
;
select $numplus;
run;

data hospitals;  
input hospnum : $4. @@;
datalines;
0001 0004 0012 0015 0016 
;
run;

title 'REPORT WRITTEN USING A NESTED FORMAT';
proc report data=hospitals nowd;  
columns hospnum hospnum=hospnam; 
define hospnam / 'name' format=$numplus.; 
run;

proc format;
value chk_date '01FEB1999'd - '31JUL1999'd = 'OK'  
other = [date9.]
;
select chk_date;
run;

data mydates;
format dt chk_date.;
input id : $3. dt : mmddyy. @@;
datalines;
123 01301999 234 02101999 456 07311999 789 12252000
;
run;

title 'DATES OUTSIDE ACCEPTABLE RANGE ARE PRINTED';
proc report data=mydates nowd;
column id dt dt=do dt=dn;
define id / 'ID #' width=4;
define dt / 'FORMATTED DATE';
define do / 'ORIGINAL DATE' format=date9.;
define dn / 'DAYS' format=best.;
run;

* EXMAPLE #4 - PRELOADING A FORMAT;

proc format;
value age
low - 15 = '<16'
16 - high = '16+'
;
run;

title 'PROC MEANS WITHOUT A PRELOADED FORMAT';
proc means data=sashelp.class mean maxdec=1;
var weight;
class sex age;
format age age.;
run;

title 'PROC MEANS WITH A PRELOADED FORMAT';
proc means data=sashelp.class mean maxdec=1 completetypes;
var weight;
class  sex age / preloadfmt;
format age age.;
run;

* FORMAT LOCATION;

proc format;
value $answer
'1' = "YES"
'2' = "NO"
'3' = "DON'T KNOW"
'4' = "OTHER"
;
run;

data results;
format answer $answer.;
input answer : $1. @@;
datalines;
1 2 3 4
;
run;

title 'FORMAT BEFORE INPUT';
proc contents data=results;
run;

data results;
input answer : $1. @@;
format answer $answer.;
datalines;
1 2 3 4
;
run;

title 'FORMAT AFTER INPUT';
proc contents data=results;
run;

* EXAMPLE #5 - MULTI-LEVEL FORMATS;

* CREATE A FORMAT WITH OVERLAPPING RANGES - USED THE MULTILABEL OPTION;	

proc format;
value age (multilabel notsorted)
11 - 13 = '11-13' 
11      = '   11' 
12      = '   12' 
13      = '   13'
14 - 16 = '14-16'
14      = '   14'
15      = '   15'
16      = '   16'
low - high = 'TOTAL'
;
run;

title 'PROC MEANS USING THE MULTILABEL FORMAT WITH OPTIONS';
proc means data=sashelp.class mean maxdec=1;
var weight;
class age /mlf preloadfmt order=data;
format age age.;
run;
